﻿using System;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace Local_Backup_Utility
{
    class Dataset
    {
        public static string[] Pack(List<string>[] dataset)
        {
            string[] formattedDataset = new string[dataset.Length];

            for (int a = 0; a < formattedDataset.Length; a++)
            {
                for (int b = 0; b < dataset[a].Count; b++)
                {
                    if (b != 0) formattedDataset[a] = formattedDataset[a] + "*";

                    formattedDataset[a] = formattedDataset[a] + dataset[a][b];
                }
            }

            return formattedDataset;
        }

        public static List<string>[] Unpack(string[] dataset)
        {
            List<string>[] formattedDataset = new List<string>[dataset.Length];

            for (int a = 0; a < formattedDataset.Length; a++)
            {
                formattedDataset[a] = new List<string>();

                string[] temp;

                if (dataset[a] == null) temp = new string[] { "(null)" };
                else temp = dataset[a].Split('*');

                for (int b = 0; b < temp.Length; b++)
                {
                    formattedDataset[a].Add(temp[b]);
                }
            }

            return formattedDataset;
        }

        public static List<string>[] Add(List<string>[] dataset, List<string> newList)
        {
            List<string>[] formattedDataset;

            if (dataset == null)
            {
                formattedDataset = new List<string>[1];

                formattedDataset[0] = newList;
            }
            else
            {
                formattedDataset = new List<string>[dataset.Length + 1];

                for (int a = 0; a < formattedDataset.Length; a++)
                {
                    if (a == dataset.Length)
                    {
                        formattedDataset[a] = newList;
                        break;
                    }

                    formattedDataset[a] = dataset[a];
                }
            }

            return formattedDataset;
        }

        public static List<string>[] Remove(List<string>[] dataset, int index)
        {
            bool removed = false;
            List<string>[] formattedDataset = new List<string>[dataset.Length - 1];

            for (int a = 0; a < formattedDataset.Length; a++)
            {
                if (a == index) removed = true;

                if(removed == false) formattedDataset[a] = dataset[a];
                else formattedDataset[a] = dataset[a + 1];
            }

            return formattedDataset;
        }

        public static List<string>[] Replace(List<string>[] dataset, List<string> newList, int index)
        {
            List<string>[] formattedDataset = new List<string>[dataset.Length];

            if(newList.Count == 0) newList.Add("(null)");

            for (int a = 0; a < formattedDataset.Length; a++)
            {
                if (a == index) formattedDataset[a] = newList;

                else formattedDataset[a] = dataset[a];
            }

            return formattedDataset;
        }

        public static void SaveAll()
        {
            StringCollection sourcesCollection = new StringCollection();
            sourcesCollection.AddRange(FormMain.sources.ToArray());
            Properties.Settings.Default.sources = sourcesCollection;

            StringCollection destinationsCollection = new StringCollection();
            destinationsCollection.AddRange(FormMain.destinations.ToArray());
            Properties.Settings.Default.destinations = destinationsCollection;

            StringCollection exceptionsCollection = new StringCollection();
            exceptionsCollection.AddRange(Dataset.Pack(FormMain.exceptions).ToArray());
            Properties.Settings.Default.exceptions = exceptionsCollection;

            Properties.Settings.Default.Save();
        }

        public static void SaveExceptions()
        {
            StringCollection exceptionsCollection = new StringCollection();
            exceptionsCollection.AddRange(Dataset.Pack(FormMain.exceptions).ToArray());
            Properties.Settings.Default.exceptions = exceptionsCollection;

            Properties.Settings.Default.Save();
        }
    }
}


/* --- DEBUG --- 

string[] dataset = { "1*2*3*4*5", "6*7*8*9" };

MessageBox.Show("Length of source: " + dataset.Length);

List<string>[] list = Dataset.Unpack(dataset);

MessageBox.Show("Length of destination: " + list[0].Count + ", " + list[1].Count);

dataset = Dataset.Pack(list);

MessageBox.Show("dataset0: " + dataset[0] + ", dataset1:" + dataset[1]);

List<string> newList = new List<string>();

newList.Add("10"); newList.Add("11"); newList.Add("12");

list = Dataset.Add(list, newList);

MessageBox.Show("Length of lists: " + list[0].Count + ", " + list[1].Count + ", " + list[2].Count);

list = Dataset.Replace(list, newList, 1);

MessageBox.Show("Length of lists: " + list[0].Count + ", " + list[1].Count + ", " + list[2].Count);

 --- DEBUG --- */