﻿using System;
using System.Data;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Threading.Tasks;
using System.Collections.Generic;

namespace Local_Backup_Utility
{
    public partial class FormCalculateTimerDebug : Form
    {
        bool ready = false;

        string[] daysOfWeek = new string[] { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };

        public FormCalculateTimerDebug()
        {
            InitializeComponent();
        }

        /*
         * schedule[0] = enabled/disabled
         * schedule[1] = Minutely/Hourly/Daily/Weekly/Monthly
         * schedule[2] = (hour)
         * schedule[3] = (minute)
         * schedule[4] = AM/PM
         * schedule[5] = Sunday/Monday/Tuesday/Wednesday/Thursday/Friday/Saturday
         * schedule[6] = (day of month)
         */

        private void FormCalculateTimerDebug_Load(object sender, EventArgs e)
        {
            if (Properties.Settings.Default.theme == "dark")
            {
                this.BackColor = Color.FromArgb(26, 26, 27);
                Themes.changeTheme("dark", this.Controls);
            }

            comboFrequency.SelectedItem = Properties.Settings.Default.schedule[1];

            currentComboHour.SelectedItem = Convert.ToInt32(DateTime.Now.ToString("hh")).ToString();
            currentComboMinute.SelectedItem = DateTime.Now.ToString("mm");
            if (DateTime.Now.ToString("tt") == "AM") currentRadioAM.Checked = true;
            else if (DateTime.Now.ToString("tt") == "PM") currentRadioPM.Checked = true;
            currentComboMonth.SelectedItem = DateTime.Now.Month.ToString();
            currentComboYear.SelectedItem = DateTime.Now.Year.ToString();

            currentComboDayOfWeek.SelectedItem = DateTime.Now.DayOfWeek.ToString();
            currentComboDayOfMonth.SelectedItem = DateTime.Now.Day.ToString();

            targetComboHour.SelectedItem = Properties.Settings.Default.schedule[2];
            targetComboMinute.SelectedItem = Properties.Settings.Default.schedule[3];
            if (Properties.Settings.Default.schedule[4] == "AM") targetRadioAM.Checked = true;
            else if (Properties.Settings.Default.schedule[4] == "PM") targetRadioPM.Checked = true;

            targetComboDayOfWeek.SelectedItem = Properties.Settings.Default.schedule[5];
            targetComboDayOfMonth.SelectedItem = Properties.Settings.Default.schedule[6];

            ready = true;
            configureControls();
        }

        private void comboFrequency_SelectedIndexChanged(object sender, EventArgs e)
        {
            configureControls();
        }

        void configureControls()
        {
            if (ready == false) return;

            if (comboFrequency.SelectedItem.ToString() == "Minutely")
            {
                targetComboHour.Enabled = false;
                targetComboMinute.Enabled = false;
                targetRadioAM.Enabled = false;
                targetRadioPM.Enabled = false;
                targetComboDayOfWeek.Enabled = false;
                targetComboDayOfMonth.Enabled = false;

                targetGroupTime.Visible = false;
                targetGroupDayOfWeek.Visible = false;
                targetGroupDayOfMonth.Visible = false;
            }

            if (comboFrequency.SelectedItem.ToString() == "Hourly")
            {
                targetComboHour.Enabled = false;
                targetComboMinute.Enabled = true;
                targetRadioAM.Enabled = false;
                targetRadioPM.Enabled = false;
                targetComboDayOfWeek.Enabled = false;
                targetComboDayOfMonth.Enabled = false;

                targetGroupTime.Visible = true;
                targetGroupDayOfWeek.Visible = false;
                targetGroupDayOfMonth.Visible = false;
            }

            if (comboFrequency.SelectedItem.ToString() == "Daily")
            {
                targetComboHour.Enabled = true;
                targetComboMinute.Enabled = true;
                targetRadioAM.Enabled = true;
                targetRadioPM.Enabled = true;
                targetComboDayOfWeek.Enabled = false;
                targetComboDayOfMonth.Enabled = false;

                targetGroupTime.Visible = true;
                targetGroupDayOfWeek.Visible = false;
                targetGroupDayOfMonth.Visible = false;
            }

            if (comboFrequency.SelectedItem.ToString() == "Weekly")
            {
                targetComboHour.Enabled = true;
                targetComboMinute.Enabled = true;
                targetRadioAM.Enabled = true;
                targetRadioPM.Enabled = true;
                targetComboDayOfWeek.Enabled = true;
                targetComboDayOfMonth.Enabled = false;

                targetGroupTime.Visible = true;
                targetGroupDayOfWeek.Visible = true;
                targetGroupDayOfMonth.Visible = false;
            }

            if (comboFrequency.SelectedItem.ToString() == "Monthly")
            {
                targetComboHour.Enabled = true;
                targetComboMinute.Enabled = true;
                targetRadioAM.Enabled = true;
                targetRadioPM.Enabled = true;
                targetComboDayOfWeek.Enabled = false;
                targetComboDayOfMonth.Enabled = true;

                targetGroupTime.Visible = true;
                targetGroupDayOfWeek.Visible = false;
                targetGroupDayOfMonth.Visible = true;
            }
        }

        private void buttonTest_Click(object sender, EventArgs e)
        {
            TimeSpan nextTime = calculateTimer();

            labelNextBackup.Text = "Next backup: " + nextTime.Days + " days, " + nextTime.Hours + " hours, " + nextTime.Minutes + " minutes, " + nextTime.Seconds + " seconds";
        }

        TimeSpan calculateTimer()
        {
            int hour = Convert.ToInt32(currentComboHour.SelectedItem.ToString());
            if (currentRadioAM.Checked == true && hour == 12) hour = 0;
            if (currentRadioPM.Checked == true && hour != 12) hour += 12;

            DateTime currentTime = new DateTime(
                Convert.ToInt32(currentComboYear.SelectedItem.ToString()),
                Convert.ToInt32(currentComboMonth.SelectedItem.ToString()),
                Convert.ToInt32(currentComboDayOfMonth.SelectedItem.ToString()),
                hour,
                Convert.ToInt32(currentComboMinute.SelectedItem.ToString()),
                DateTime.Now.Second);

            DateTime targetTime = new DateTime();

            int savedMinute = Convert.ToInt32(targetComboMinute.SelectedItem.ToString()); 
            int savedHour = Convert.ToInt32(targetComboHour.SelectedItem.ToString());

            if (targetRadioAM.Checked == true && savedHour == 12) savedHour = 0;
            if (targetRadioPM.Checked == true && savedHour != 12) savedHour += 12;

            if (comboFrequency.SelectedItem.ToString() == "Minutely")
            {
                targetTime = new DateTime(currentTime.Year, currentTime.Month, currentTime.Day, currentTime.Hour, currentTime.Minute, 0);
                targetTime = targetTime.AddMinutes(1);

                if (targetTime <= currentTime) targetTime = targetTime.AddHours(1);
            }

            if (comboFrequency.SelectedItem.ToString() == "Hourly")
            {
                targetTime = new DateTime(currentTime.Year, currentTime.Month, currentTime.Day, currentTime.Hour, savedMinute, 0);
                if (targetTime <= currentTime) targetTime = targetTime.AddHours(1);
                if (targetTime <= currentTime) targetTime = targetTime.AddDays(1);
            }

            if (comboFrequency.SelectedItem.ToString() == "Daily")
            {
                targetTime = new DateTime(currentTime.Year, currentTime.Month, currentTime.Day, savedHour, savedMinute, 0);
                if (targetTime <= currentTime) targetTime = targetTime.AddDays(1);
            }

            if (comboFrequency.SelectedItem.ToString() == "Weekly")
            {
                //int savedDayOfWeek = Array.IndexOf(daysOfWeek, Properties.Settings.Default.schedule[5]) + 1;
                //int currentDayOfWeek = Array.IndexOf(daysOfWeek, DateTime.Today.DayOfWeek.ToString()) + 1;
                int savedDayOfWeek = Array.IndexOf(daysOfWeek, targetComboDayOfWeek.SelectedItem.ToString()) + 1;
                int currentDayOfWeek = Array.IndexOf(daysOfWeek, currentComboDayOfWeek.SelectedItem.ToString()) + 1;
                int daysIntil;

                if (savedDayOfWeek >= currentDayOfWeek) daysIntil = savedDayOfWeek - currentDayOfWeek;
                else daysIntil = savedDayOfWeek - currentDayOfWeek + 7;

                targetTime = new DateTime(currentTime.Year, currentTime.Month, currentTime.Day, savedHour, savedMinute, 0);
                targetTime = targetTime.AddDays(daysIntil);
                if (targetTime <= currentTime) targetTime = targetTime.AddDays(7);
            }

            if (comboFrequency.SelectedItem.ToString() == "Monthly")
            {
                //int savedDayOfMonth = Convert.ToInt32(Properties.Settings.Default.schedule[6]);
                int savedDayOfMonth = Convert.ToInt32(targetComboDayOfMonth.SelectedItem.ToString());

                if (savedDayOfMonth > DateTime.DaysInMonth(currentTime.Year, currentTime.Month)) savedDayOfMonth = DateTime.DaysInMonth(currentTime.Year, currentTime.Month);

                targetTime = new DateTime(currentTime.Year, currentTime.Month, savedDayOfMonth, savedHour, savedMinute, 0);
                if (targetTime <= currentTime) targetTime = targetTime.AddMonths(1);
                if (targetTime <= currentTime) targetTime = targetTime.AddDays(1);
            }

            TimeSpan nextTime = targetTime - currentTime;
            return nextTime;
        }
    }
}
