﻿using System;
using System.Data;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace Local_Backup_Utility
{
    public partial class FormExceptions : Form
    {
        int index;

        public FormExceptions(int _index)
        {
            InitializeComponent();

            index = _index;
        }

        private void FormExceptions_Load(object sender, EventArgs e)
        {
            if (Properties.Settings.Default.theme == "dark")
            {
                this.BackColor = Color.FromArgb(26, 26, 27);
                Themes.changeTheme("dark", this.Controls);
            }

            textSource.Text = FormMain.sources[index];
            textDestination.Text = FormMain.destinations[index];

            if (FormMain.exceptions[index][0] != "(null)")
            {
                listExceptions.Items.AddRange(FormMain.exceptions[index].Cast<string>().ToArray());
            }
        }

        private void buttonFiles_Click(object sender, EventArgs e)
        {
            if(openFileDialog.ShowDialog() == DialogResult.OK)
            {
                listExceptions.Items.AddRange(openFileDialog.FileNames);
            }

            FormMain.exceptions = Dataset.Replace(FormMain.exceptions, listExceptions.Items.Cast<string>().ToList(), index);
            Dataset.SaveExceptions();
        }

        private void buttonFolder_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
            {
                listExceptions.Items.Add(folderBrowserDialog.SelectedPath);
            }

            FormMain.exceptions = Dataset.Replace(FormMain.exceptions, listExceptions.Items.Cast<string>().ToList(), index);
            Dataset.SaveExceptions();
        }

        private void buttonRemove_Click(object sender, EventArgs e)
        {
            if(listExceptions.SelectedIndex == -1)
            {
                MessageBox.Show("No items selected");
                return;
            }

            while (listExceptions.SelectedItems.Count > 0) listExceptions.Items.RemoveAt(listExceptions.SelectedIndices[0]);

            FormMain.exceptions = Dataset.Replace(FormMain.exceptions, listExceptions.Items.Cast<string>().ToList(), index);
            Dataset.SaveExceptions();
        }

        private void listExceptions_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete) buttonRemove.PerformClick();
            e.Handled = true;
        }
    }
}
