﻿using System;
using System.IO;
using System.Net;
using System.Data;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.ComponentModel;
using System.Threading.Tasks;
using System.Collections.Generic;

namespace Local_Backup_Utility
{
    public partial class FormUpdate : Form
    {
        string[] lines;

        public FormUpdate()
        {
            InitializeComponent();
        }

        private void FormUpdate_Load(object sender, EventArgs e)
        {
            if (Properties.Settings.Default.theme == "dark")
            {
                this.BackColor = Color.FromArgb(26, 26, 27);
                Themes.changeTheme("dark", this.Controls);
            }

            try
            {
                WebClient web = new WebClient();
                Stream stream = web.OpenRead("http://www.lycogala.com/software/LocalBackupUtility.txt");

                using (StreamReader reader = new StreamReader(stream))
                {
                    string text = reader.ReadToEnd();
                    lines = text.Split(new[] { '\r', '\n' }, StringSplitOptions.RemoveEmptyEntries);

                    labelAvailable.Text = "An update is available: v" + lines[0];
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Unable to check at this time" + Environment.NewLine + "Please try again later");
                this.Close();
            }
        }

        private void linkChangelog_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("http://www.lycogala.com/software/localbackuputility/changelog.html");
        }

        private void buttonDownload_Click(object sender, EventArgs e)
        {
            Process.Start(lines[1]);
            this.Close();
        }

        private void buttonNotNow_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
